#include     <stdio.h>      /*׼*/
#include     <stdlib.h>     /*׼ⶨ*/
#include     <unistd.h>     /*Unix ׼*/
#include     <sys/types.h>
#include     <sys/stat.h>
#include     <fcntl.h>      /*ļƶ*/
#include     <termios.h>    /*PPSIX ն˿ƶ*/
#include     <errno.h>      /*Ŷ*/
#include 	 <sys/time.h>
#include	 <time.h>
#include     <stdbool.h>
#include     <sys/sem.h>

void Delay(int ms);
int ReadData(int fd, unsigned char *read_buff, int count, int ms);
int WriteData(int fd, unsigned char *read_buff, int count);
unsigned short Read_LW(unsigned int n);
void Write_LW(unsigned int n, unsigned short val);
void CopyToLW(unsigned int offset, const void *src, int n);
void CopyFromLW(unsigned int offset, const void *src, int n);
void SetLBON(unsigned int n);
void SetLBOFF(unsigned int n);
int GetLB(unsigned int n);
int SetLWBON(unsigned int n, unsigned int offset);
int SetLWBOFF(unsigned int n, unsigned int offset);
int GetLWB(unsigned int n, unsigned int offset);
int set_sp_speed(int fd, int nSpeed);

/*
	Command
*/
#define CMD_UCW 0x25		//Uncertified weighing
#define CMD_CW 0x59		//certified weighing

/*
	Answers
*/
#define	ANSWERS_EXE 0x30	//Command executed
#define	ANSWERS_ERR 0x31	//Job pending cannot execute, etc.
#define	ANSWERS_EASE 0x35	//Scale not at ease
#define TIMEOUT 100;		//100ms

void ProcessComx(int fd)
{
	unsigned char send_data[4];
	unsigned char receive_data[1024], tmp_buf[20];
	// int TIMEOUT;
	unsigned int len_rev = 0;
	int ret = 0;
	int frame_ok = 1;
	unsigned int retry = 0;
	double weight = 0;
	static int bags = 0;
	// send_data[0] = 0x71;
	// send_data[2] = 0x0d;
	// send_data[3] = 0x0a;
	while (1) {
		//Get uncertified weighing
		send_data[0] = 0x71;
		send_data[1] = CMD_UCW;
		send_data[2] = 0x0d;
		send_data[3] = 0x0a;
		WriteData(fd, send_data, 4);
		len_rev = 0;
		memset(receive_data, 0, sizeof(receive_data));
		do {
			ret	= ReadData(fd, tmp_buf, 20, TIMEOUT);
			if (ret > 0) {
				memcpy(receive_data + len_rev, tmp_buf, ret);
				len_rev += ret;
			} else {
				break;						//read time out, break read loop
			}
			if (len_rev >= 4) {
				if (receive_data[0] == 0x77	//another job is pending, break read loop
				    && receive_data[1] == 0x31
				    && receive_data[2] == 0x0d
				    && receive_data[3] == 0x0a) {
					break;
				}
			}
		} while (len_rev >= 15 );
		//for(i=0;i<20;i++)
		//	printf("%d ", receive[i]);
		if (len_rev >= 15) {
			if (receive_data[0] == 0x2b
			    && receive_data[1] == 0x21
			    && receive_data[2] == 0x20
			    && receive_data[11] == 0x6b
			    && receive_data[12] == 0x67
			    && receive_data[13] == 0x0d
			    && receive_data[14] == 0x0a) {
				weight = receive_data[3] * 100000 + receive_data[4] * 10000 + receive_data[5] * 1000 +
				         receive_data[6] * 100 + receive_data[7] * 10 + receive_data[8] + receive_data[10] * 0.1;
				Write_LW(0, weight);
			}
		}
		//Get Certified weighing
		send_data[0] = 0x71;
		send_data[1] = CMD_CW;
		send_data[2] = 0x0d;
		send_data[3] = 0x0a;
		WriteData(fd, send_data, 4);
		len_rev = 0;
		memset(receive_data, 0, sizeof(receive_data));
		do {
			ret	= ReadData(fd, tmp_buf, 20, TIMEOUT);
			if (ret > 0) {
				memcpy(receive_data + len_rev, tmp_buf, ret);
				len_rev += ret;
			} else {
				break;						//read time out, break read loop
			}
			if (len_rev >= 4) {
				if (receive_data[0] == 0x77	//another job is pending, break read loop
				    && (receive_data[1] == ANSWERS_ERR || receive_data[1] == ANSWERS_EASE)
				    && receive_data[2] == 0x0d
				    && receive_data[3] == 0x0a) {
					break;
				}
			}
		} while (len_rev >= 15 );
		//for(i=0;i<20;i++)
		//	printf("%d ", receive[i]);
		if (len_rev >= 15) {
			if (receive_data[0] == 0x2b
			    && receive_data[1] == 0x21
			    && receive_data[2] == 0x20
			    && receive_data[11] == 0x6b
			    && receive_data[12] == 0x67
			    && receive_data[13] == 0x0d
			    && receive_data[14] == 0x0a) {
				weight = receive_data[3] * 100000 + receive_data[4] * 10000 + receive_data[5] * 1000 +
				         receive_data[6] * 100 + receive_data[7] * 10 + receive_data[8] + receive_data[10] * 0.1;
				Write_LW(4, weight);
			}
		}
//			send_data[1] = 0x59;
//			WriteData(fd, send_data, 4);
//			TIMEOUT = 100;//ms
//			ReadData(fd, receive_data, 20, TIMEOUT);
//			//for(i=0;i<20;i++)
//			//	printf("%d ", receive[i]);
//			if (receive_data[1] == 0x31 || receive_data[31] == 0x35)
//				continue;
//			weight = receive_data[3] * 100000 + receive_data[4] * 10000 + receive_data[5] * 1000 +
//			         receive_data[6] * 100 + receive_data[7] * 10 + receive_data[8] + receive_data[10] * 0.1;
//			Write_LW(4, weight);
//			//ܼ
//			bags++;
//			Write_LW(8, bags);
	}
}
